library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use work.Aufg5_Pack.all;

entity TestMain is
Port (
		clk : in std_logic;
	--	sw : in std_logic_vector(7 downto 0);
		btn : in std_logic_vector(3 downto 0);
		led : out std_logic_vector(7 downto 0);
		seg7an: out std_logic_vector(3 downto 0);
		seg7ca: out std_logic_vector(6 downto 0);
		sio_RxD : in std_logic; 		-- serieller Eingang
		sio_TxD : out std_logic:='1'; -- serieller Ausgang
		sendEn : out std_logic;
		recvEn : out std_logic;
		Funk_RxD : in std_logic;
		Funk_TxD : out std_logic
	);
end TestMain;

architecture Behavioral of TestMain is

--signal slaveID : std_logic_vector(7 downto 0):="00110001";  -- 31 -- ASCII : 1
--signal slaveID : std_logic_vector(7 downto 0):="00110010";  -- 32 -- ASCII : 2
signal slaveID : std_logic_vector(7 downto 0):="00110011";  -- 33 -- ASCII : 3

signal CLKQ  : std_logic_vector(1 downto 0);

signal Cnt_13micro1 : integer;
signal Cnt_13micro0 : integer;
signal Cnt_13micro : integer;

signal State : integer;
signal state_E : integer;
signal State_Bit : Integer;
signal State_Stop : Integer;
signal State_daten : Integer;
signal LFunk_RxD : Std_logic;
signal start_emp : Std_logic_vector(7 downto 0);
signal sum_send : Std_logic_vector(7 downto 0);
signal sum_emp : Std_logic_vector(7 downto 0);
signal sum_emp1 : Std_logic_vector(7 downto 0);
signal sum_OK : std_logic;
signal daten : Std_logic_vector(11 downto 0);
signal daten_SUM : Std_logic_vector(11 downto 0);

signal Buffer_Index : integer range 0 to 12:=0;
signal Buffer_Index_E : integer range 0 to 12:=0;
type TbufferRam is array(0 to 3) of std_logic_vector(0 to 7);  -- Maxmal RAM 256 * 8 Bits  / also 256 Bytes
--signal bufferRam : TbufferRam;
type bufferRam is array(0 to 11) of std_logic_vector(0 to 7);  -- Maxmal RAM 256 * 8 Bits  / also 256 Bytes
Signal RS232Ram : bufferRam;
signal Ram1 : bufferRam;
signal Ram2 : TbufferRam;

--signal LencodeZahl : integer;

signal decode_input  : std_logic_vector(11 downto 0);
signal decode_output : std_logic_vector(7 downto 0);
signal Encode_input  : std_logic_vector(7 downto 0);
signal Encode_output : std_logic_vector(11 downto 0);

---RS232---
signal Baude_CLK: std_logic;   						-- 16-facher Baudetakt
signal RxD_del: std_logic_vector(1 downto 0);   -- verz&#246;gertes empf. Sig.
signal StateE: integer range 0 to 14:=0;  			-- Zustand Empfangsautomat
signal Q: std_logic_vector(7 downto 0); 			-- Empfangsschieberegister
signal Q_1 : std_logic;
signal sdaten: std_logic_vector(7 downto 0); 			-- 
signal busy: std_logic; 								-- Signal zum Anschalten des 1:16 Teilers und des Empf&#228;ngers
signal busyS: std_logic; 								-- Signal zum Anschalten des 1:16 Teilers und des Empf&#228;ngers
signal StateS: integer range 0 to 13:=0;  		-- Zustand Empfangsautomat
signal a0: std_logic_vector(7 downto 0);
signal a1: std_logic_vector(7 downto 0);

signal ram_index_1 : integer range 0 to 12:=0;
signal ram_index_2 : integer range 0 to 4:=0;
signal full_int: std_logic:= '0';
signal full_int_E: std_logic:= '1';
-----------
Component Encode is
	Port (
			input  :  in  std_logic_vector(7 downto 0);
		   output :  out std_logic_vector(11 downto 0)
		  );
end Component;

Component decode is
	Port (
			input  :  in  std_logic_vector(11 downto 0);
		   output :  out std_logic_vector(7 downto 0)
		  );
end Component;

---------- Begin ----------
begin
-------------------------  R A M ------
----- das  muss von einem Buffer Kommen
----- hier ist nur ein Beispiel
--bufferRam(0) <= sw;
--bufferRam(1) <= x"52";
--bufferRam(2) <= x"73";
--bufferRam(3) <= x"E4";
----------------------------------------
Inst_Encode : Encode port map
	(
	 Input  => Encode_input,
	 Output  => Encode_output
	 );
	 
Inst_Decode : decode port map
	(
	 Input  => decode_input,
	 Output  => decode_output
	 );
---------- Frequenzen ----------
process(clk)
variable ClkVT: integer range 0 to 161:=0;
begin
if clk'event and clk='1' then
	CLKQ <= CLKQ + '1';
	if ClkVT=161 then
		ClkVT:=0;
		Baude_CLK<=not Baude_CLK;
	else
		ClkVT:=ClkVT+1;
	end if;
end if;
end process;

---------- Funk Teilprogramm ----------	 
process(CLKQ(0))

variable Taktlange : integer:=325;

variable cnt : integer;
variable cnt_empeins : integer;
variable cnt_empnull : integer;
variable preamble : integer;
variable int : integer;
variable state_Bit_E : integer;
variable state_SUM_E : integer;
	
begin
---------- Funk Sender ----------
if btn = "1000" then
	sendEn <= '0';
	recvEn <= '1';
	if rising_edge(CLKQ(0)) then
		case State is
			when 0=>   --- Reset
				sum_send <= "00000000";
				Buffer_Index <= 0;
				State_daten <= 0;
				Cnt_13micro1<=0;
				Cnt_13micro0<=0;
				State<=State+1;
			when 1 to 80=>  -- Preamble 160 Bits "101010......101010" senden
				if Cnt_13micro1 < Taktlange then
					Funk_TxD <= '1';
					Cnt_13micro1 <= Cnt_13micro1+1;
				elsif Cnt_13micro0 < Taktlange then
					Funk_TxD <= '0';
					Cnt_13micro0 <= Cnt_13micro0+1;
				else
					Cnt_13micro0 <= 0;
					Cnt_13micro1 <= 0;
					State <= State + 1;
				end if;
			when 81 =>  -- Start "00001111" senden  
				if Cnt_13micro0 < Taktlange*4 then	-- "0000"
					Funk_TxD <= '0';
					Cnt_13micro0 <= Cnt_13micro0+1;
				elsif Cnt_13micro1 < Taktlange*4 then	-- "1111"
					Funk_TxD <= '1';
					Cnt_13micro1 <= Cnt_13micro1+1;
				else
					Cnt_13micro0 <= 0;
					Cnt_13micro1 <= 0;
					State <= State+1;
				end if;	
			when 82 =>			-- Daten senden
				if State_daten >= 12 then  -- Wie viele Bytes ? 
					State_daten <= 0;
					State <= State + 1;
				else
				--	Encode_input <= BufferRam(Buffer_Index);
					Encode_input <= RS232Ram(Buffer_Index);
				--	sum_send <= sum_send XOR BufferRam(Buffer_Index);
					sum_send <= sum_send XOR RS232Ram(Buffer_Index);
					case State_Bit is		
						when 0 to 11 =>	 
							if Cnt_13micro < Taktlange then
								Funk_TxD <= Encode_output(State_Bit);
								Cnt_13micro <= Cnt_13micro+1;
							else
								Cnt_13micro <= 0;
								State_Bit <= State_Bit + 1;
							end if;
						when others =>
							State_daten <= State_daten + 1;
							Buffer_Index <= Buffer_Index + 1;
							State_Bit <= 0;
					end case;
				end if;
			--- SUM senden------- schon getestet -----
			when 83 =>
				Encode_input <= sum_send;
				case State_Bit is		
					when 0 to 11 =>	 
						if Cnt_13micro < Taktlange then
							Funk_TxD <= Encode_output(State_Bit);
							Cnt_13micro <= Cnt_13micro+1;
						else
							Cnt_13micro <= 0;
							State_Bit <= State_Bit + 1;
						end if;
					when others =>
						State_Bit <= 0;
						State <= State + 1;
				end case;
			---------------------
			when 84 =>		-- Stop Bits "00" senden
				case State_Stop is		
					when 0 to 1 =>	 
						if Cnt_13micro < Taktlange then
							Funk_TxD <= '0';
							Cnt_13micro <= Cnt_13micro+1;
						else
							Cnt_13micro <= 0;
							State_Stop <= State_Stop + 1;
						end if;
					when others=>
						State_Stop <= 0;
						State <= State + 1;
				end case;
			when others=>
		--		full_int <= '0';
				State <= 0;
		end case ;
	end if;
---------- Funk Empfnger ----------
else
	sendEn <= '1';
	recvEn <= '0';
	if rising_edge(CLKQ(0)) then
		LFunk_RxD<=Funk_RxD;
		case state_E is 
			when 0 =>
				cnt_empeins := 0;
				cnt_empnull := 0;
				preamble := 0;
				cnt := 0;
				int := 0;
				state_SUM_E := 0;
				state_Bit_E := 0;
				Buffer_Index_E <= 0;
				sum_emp <= "00000000";
				sum_emp1 <= "00000000";
				state_E <= 1;
			when 1 =>
				if LFunk_RxD = '1' and Funk_RxD = '1' then
					cnt_empeins := cnt_empeins + 1;
				end if;
				if LFunk_RxD = '1' and Funk_RxD = '0' then
					if cnt_empeins >= 320 and cnt_empeins <= 330 then
						preamble := preamble + 1;
						cnt_empeins := 0;
						if preamble < 159 then
							state_E <= 2;
						else
							state_E <= 3;
						end if;	
					else
						state_E <= 0;					
					end if;
				end if;	
			when 2 =>
				if LFunk_RxD = '0' and Funk_RxD = '0' then
					cnt_empnull := cnt_empnull + 1;
				end if;
				if LFunk_RxD = '0' and Funk_RxD = '1' then
					if cnt_empnull >= 320 and cnt_empnull <= 330 then
						preamble := preamble + 1;
						cnt_empnull := 0;
						state_E <= 1;
					else
						state_E <= 0;
					end if;
				end if;	
			when 3 =>
				cnt := cnt + 1;
				if cnt = 162 then
					if LFunk_RxD = '0' and Funk_RxD = '0' then
						cnt := 0;
						state_E <= 4;
					else
						state_E <= 0;
					end if;
				end if;
			when 4 to 11=>
				cnt := cnt + 1;
				if cnt = 325 then
					start_emp(state_E - 4) <= Funk_RxD;
					cnt := 0;
					state_E <= state_E + 1;
				end if;	
			when 12 =>
				if start_emp = "11110000" then
					state_Bit_E := 0;
					state_E <= 13;
				else
					state_E <= 0;
				end if;
			when 13 => 			-- empfngde Daten in RAM speichern
				case state_Bit_E is
					when 0 to 11 =>
						cnt := cnt + 1;
						if cnt = 325 then
							daten(state_Bit_E) <= Funk_RxD;
							cnt := 0;
							state_Bit_E := state_Bit_E + 1;
						end if;
					when 12 =>
						decode_input <= daten;
						state_Bit_E := state_Bit_E + 1;
					when 13 =>
						Ram1(Buffer_Index_E) <= decode_output;
					--	Rs232Ram(Buffer_Index_E) <= decode_output;
						state_Bit_E := state_Bit_E + 1;
					when 14=>
					   sum_emp <= sum_emp XOR Ram1(Buffer_Index_E); -- SUM rechnen
					--	sum_emp <= sum_emp XOR RS232Ram(Buffer_Index_E); -- SUM rechnen
						state_Bit_E := state_Bit_E + 1;
					when others =>
						if buffer_index_E < 11 then
							buffer_index_E <= buffer_index_E + 1;
							state_Bit_E := 0;
							state_E <= 13;
						else
							state_SUM_E := 0;
							cnt := 0;
							state_E <= 14;
						end if;
					end case;
-----------------------SUM empfaengen------------
			when 14 =>
				case state_SUM_E is
					when 0 to 11 =>
						cnt := cnt + 1;
						if cnt = 325 then
							daten_SUM(state_SUM_E) <= Funk_RxD;
							cnt := 0;
							state_SUM_E := state_SUM_E + 1;
						end if;
					when 12 =>
						decode_input <= daten_SUM;
						state_SUM_E := state_SUM_E + 1;
					when 13 =>
						sum_emp1 <= decode_output;
						state_SUM_E := state_SUM_E + 1;
					when others =>
						if sum_emp1 = sum_emp then
							state_E <= 15;
							sum_OK <= '1';
						else
							sum_OK <= '0';
							state_E <= 0;
						end if;
				end case;
----------------------------------------------------
			when 15 =>
				led <= Ram1(11);
				state_E <= 16;
			when others =>
				state_E <= 0;
		end case;
	end if;

end if;

end process;

---------- RS232 Teilprogramm ----------
process(Baude_CLK)
variable ClkDiv: std_logic_vector(3 downto 0);
variable ClkDivS: std_logic_vector(3 downto 0);
variable outp: std_logic_vector(6 downto 0);
variable hpstate: integer range 0 to 3:=0;

begin
if Baude_CLK'event and Baude_CLK='1' then
---------- von RS232 zu FPGA ----------	   
	RxD_del<=RxD_del(0) & sio_RxD;
	if RxD_del="10" and busy='0' and full_int = '0' then
		ClkDiv:=x"0";
		busy<='1';
   elsif busy='1' then
		ClkDiv:=ClkDiv+'1';
   end if;

	if ClkDiv=x"8" and busy='1' and full_int = '0' then
	--	StateE<=StateE+1;
		case StateE is
			when 0 =>
				Q_1 <= sio_RxD;	-- Startbit
				StateE <= 1;
			when 1 =>        		-- Datenbits
				Q(0)<= sio_RxD;
				StateE <= 2;
			when 2 =>  				
				Q(1)<= sio_RxD;
				StateE <= 3;
			when 3 =>  
				Q(2)<= sio_RxD;
				StateE <= 4;
			when 4 =>  
				Q(3)<= sio_RxD;
				StateE <= 5;
			when 5 =>  
				Q(4)<= sio_RxD;
				StateE <= 6;
			when 6 =>  
				Q(5)<= sio_RxD;
				StateE <= 7;
			when 7 =>  
				Q(6)<= sio_RxD;
				StateE <= 8;
			when 8 =>  
				Q(7)<= sio_RxD;
				StateE <= 9;
			when 9 =>
				if full_int = '0' then
					RS232Ram(ram_index_1) <= Q(7 downto 0);
				   if ram_index_1 = 11 then
						full_int <= '1';
						ram_index_1 <= 0;
						StateE <= 11;
					else
						ram_index_1 <= ram_index_1 + 1;
						StateE <= 10;
					end if;
				end if;
			when 10 =>
				StateE <= 1;
			when others =>
				StateE <= 0;
				busy<='0';
		end case;
	end if;
	
	if btn = "1000" then
		full_int <= '0';
	end if;
--==========================================================
-- kombinatorische Ausgabe
-- Ausgabe des Schieberegisterzustandes
--	led(7 downto 0) <= Ram1(11);
	a0 <= RS232Ram(11);
	a1 <= RS232Ram(0);
--	a0 <= Ram1(3);
--	a1 <= Ram1(0);
	
	case hpstate is
		when 0 =>
			seg7ca<= Hex2Seg7(a0(7 downto 4)); -- Ausgabewert Kathode
			seg7an<="1101"; -- Ausgabewert Anode
			hpstate:=hpstate+1; -- Folgezustand zuweisen
		when 1 =>
			seg7ca<= Hex2Seg7(a0(3 downto 0)); -- Ausgabewert Kathode
			seg7an<="1110"; -- Ausgabewert Anode
			hpstate:=hpstate+1; -- Folgezustand zuweisen
		when 2 =>
			seg7ca<= Hex2Seg7(a1(7 downto 4)); -- Ausgabewert Kathode
			seg7an<="0111"; -- Ausgabewert Anode
			hpstate:=hpstate+1; -- Folgezustand zuweisen
		when 3 =>
			seg7ca<= Hex2Seg7(a1(3 downto 0)); -- Ausgabewert Kathode
			seg7an<="1011"; -- Ausgabewert Anode   
			hpstate:=0;
	end case; 
------------------------------------------------------------
if sum_OK = '1' then
	if Ram1(0) = slaveID then
		Ram2(0) <= Ram1(2);
		Ram2(1) <= Ram1(3);
		Ram2(2) <= Ram1(4);
		Ram2(3) <= Ram1(5);
	end if;
	if Ram1(6) = slaveID  then
		Ram2(0) <= Ram1(8);
		Ram2(1) <= Ram1(9);
		Ram2(2) <= Ram1(10);
		Ram2(3) <= Ram1(11);
	end if;
--	if Ram1(8) = slaveID  then
--		Ram2(0) <= Ram1(8);
--		Ram2(1) <= Ram1(9);
--		Ram2(2) <= Ram1(10);
--		Ram2(3) <= Ram1(11);
--	end if;
--	if Ram1(12) = slaveID  then
--		Ram2(0) <= Ram1(12);
--		Ram2(1) <= Ram1(13);
--		Ram2(2) <= Ram1(14);
--		Ram2(3) <= Ram1(15);
--	end if;
end if;
---------- von FPGA zu RS232 ----------
	if btn = "0001" and busyS='0' and full_int_E = '1' then
		ClkDivS:=x"0";
      busyS<='1';
   elsif busyS='1' then
		ClkDivS:=ClkDivS+'1';
   end if;

	if ClkDivS=x"8" and busyS='1' and full_int_E = '1' then
	--	StateS<=StateS+1;
		case StateS is
			when 0=>
				sdaten <= Ram2(ram_index_2);
				StateS<=StateS+1;
			when 1 =>
				sio_TxD<='0';
				StateS<=StateS+1;
			when 2=>
				sio_TxD<=sdaten(0);
				StateS<=StateS+1;
			when 3=>
				sio_TxD<=sdaten(1);
				StateS<=StateS+1;
			when 4=>
				sio_TxD<=sdaten(2);
				StateS<=StateS+1;
			when 5=>
				sio_TxD<=sdaten(3);
				StateS<=StateS+1;
			when 6=>
				sio_TxD<=sdaten(4);
				StateS<=StateS+1;
			when 7=>
				sio_TxD<=sdaten(5);
				StateS<=StateS+1;
			when 8=>
				sio_TxD<=sdaten(6);
				StateS<=StateS+1;
			when 9=>
				sio_TxD<=sdaten(7);
				StateS<=StateS+1;
			when 10 =>
				sio_TxD<='1';
				StateS<=StateS+1;
--			when 10 =>
--		--		sdaten <= RS232Ram(ram_index_2);
--				sdaten <= Ram1(ram_index_2);
			when 11=>
				ram_index_2 <= ram_index_2 + 1;
				StateS<=StateS+1;
			when 12 =>
				if ram_index_2 < 4 then
					StateS <= 0;
				else
					full_int_E <= '0';
					ram_index_2 <= 0;
					StateS<=StateS+1;
				end if;
			when others =>
				if (btn(0) = '0') then
					StateS<=0;
					busyS<='0';
				--	StateS<=StateS+1;
				end if;
	end case;
	end if;
	
	if btn = "0000" then
		full_int_E <= '1';
	end if;
	
end if;
end process;
end Behavioral;